Procedure RefreshFakeConsole()

  CreateImage(#ImageFakeConsole, #FakeConsoleWidth, #FakeConsoleHeight)
    
  
    StartDrawing(ImageOutput(#ImageFakeConsole))
    
      DrawingFont(FontID(0))
      
      Box(0, 0, #FakeConsoleWidth, #FakeConsoleHeight, $FFFFFF)
      
      DrawingMode( #PB_2DDrawing_Transparent)
      
      If ListSize(FakeConsole()) - #FakeConsoleLines = 0
        GL_FakeConsole_ScrollStatus = ListSize(FakeConsole()) - #FakeConsoleLines + 1
      EndIf
      
      If ListSize(FakeConsole()) - #FakeConsoleLines < 1
        SelectElement(FakeConsole(), 0)        
        
      Else
        SelectElement(FakeConsole(), GL_FakeConsole_ScrollStatus)
      
      EndIf
      
      For line = 0 To #FakeConsoleLines - 1
        FrontColor($000000)
        DrawText(1, line * #FakeConsoleTextHeight, FakeConsole());, $000000);, $FFFFFF)
        
        If NextElement(FakeConsole()) = 0
          Break
          
        EndIf
      Next
      
      StopDrawing()
      
  If IsImage(#ImageFakeConsole)
    SetGadgetState(#FakeConsole, ImageID(#ImageFakeConsole))
    If ListSize(FakeConsole()) <= #FakeConsoleLines
      SetGadgetAttribute(#FakeConsoleScroll, #PB_ScrollBar_Maximum, 1)
      SetGadgetState(#FakeConsoleScroll, 0)
    
    Else
      SetGadgetAttribute(#FakeConsoleScroll, #PB_ScrollBar_Maximum, ListSize(FakeConsole()) - #FakeConsoleLines + 1)
      SetGadgetState(#FakeConsoleScroll, GL_FakeConsole_ScrollStatus)
      
    EndIf
  EndIf  
    
  
EndProcedure

Procedure PrintConsole(Text$)

If ListSize(FakeConsole()) = 0
  AddElement(FakeConsole())
 EndIf

LastElement(FakeConsole())

For  countchar = 1 To Len(Text$)
  Char$ = Mid(Text$, countchar, 1)
  If Char$ <> Chr(10) And Len(FakeConsole()) < #FakeConsoleChars
    FakeConsole() + Char$
  EndIf
  
  If Char$ = Chr(10) Or Len(FakeConsole()) = #FakeConsoleChars
    AddElement(FakeConsole())
    GL_FakeConsole_ScrollStatus + 1
  EndIf  
  
  If Len(FakeConsole()) = #FakeConsoleChars
    countchar -1
  EndIf
Next 

RefreshFakeConsole()

EndProcedure

Procedure PrintConsoleN(Text$)

  PrintConsole(Text$ + Chr(10))

 
EndProcedure

Procedure.s GetFamilyFlag()
  
  Select GetGadgetText(#ComboGadget_PICFamily)
    Case "PIC10"
      FAMILY$ = "-F10"
    
    Case "PIC12"
      FAMILY$ = "-F10"

    Case "PIC16"      
      FAMILY$ = "-F16"
      
    Case "PIC16L"      
      FAMILY$ = "-F16"
         
    Case "PIC18"      
      FAMILY$ = "-F18"
      
    Case "PIC18FxxKxx"
      FAMILY$ = "-F18K"
      
    Case "PIC18LFxxKxx"
      FAMILY$ = "-F18J"
      
    Case "PIC24"
      FAMILY$ = "-F24"
      
    Case "dsPIC30"      
      FAMILY$ = "-F30"
      
    Case "dsPIC33"
      FAMILY$ = "-F33"
      
  EndSelect
  
  ProcedureReturn FAMILY$
  
  
EndProcedure


Procedure ReadPreferences()
  OpenPreferences("usburnGUI.ini")
    PreferenceGroup("Window")
    GL_WindowX = ReadPreferenceLong("Xpos", 100)
    GL_WindowY = ReadPreferenceLong("Ypos", 100)
    
    PreferenceGroup("LastHEX")
    GL_LastSourceHEX$ = ReadPreferenceString("LastSource", "")
    GL_LastFirmw$ = ReadPreferenceString("LastFirmw", "")
    GL_LastWiteHEX$ = ReadPreferenceString("LastWriteHEX", "")

  
    PreferenceGroup("LastPIC")
      GL_Last_PIC = ReadPreferenceLong("LastPIC", 0)
      GL_Last_PIC_Fam = ReadPreferenceLong("LastPICFamily", 0)
      GL_Last_SOCKET = ReadPreferenceLong("LastPICSOCKET", 0) 


    PreferenceGroup("usburn")
      GL_usburnPath$ = ReadPreferenceString("Path2usburn", ".")
      
    PreferenceGroup("Misc")  
      GL_Display_HEX_reading = ReadPreferenceLong("DisplayHEX_Reading", 1)
      GL_Owner$ = ReadPreferenceString("Owner", "")
      Font$ = ReadPreferenceString("Font", "Monospace, 8")
      
    ClosePreferences()
     
  LoadFont(0, StringField(Font$, 1, ","), Val(StringField(Font$, 2, ",")))
  
  
  

  
EndProcedure

Procedure ReadPICDatabase()
  OpenPreferences("picDB.ini")
    ExaminePreferenceGroups()
    While NextPreferenceGroup() <> 0
      grpName$ = PreferenceGroupName()
      If Left(grpName$, 3) = "PIC" Or Left(grpName$, 3) = "dsP"
        ExaminePreferenceKeys()
        While NextPreferenceKey() <> 0
          AddElement(PIC())
            PIC()\Name = PreferenceKeyName()
            PIC()\Family = grpName$
            PIC()\Pins = Val(PreferenceKeyValue())
        Wend
      EndIf
    Wend
    ClosePreferences()

EndProcedure

Procedure SavePreferences()
  If FileSize("usburnGUI.ini") = -1
    CreatePreferences("usburnGUI.ini")
  Else
    OpenPreferences("usburnGUI.ini")
  EndIf
  
    PreferenceGroup("Window")
    WritePreferenceLong("Xpos", WindowX(#Window_Main))
    WritePreferenceLong("Ypos", WindowY(#Window_Main))
    
    PreferenceGroup("LastHEX")
    WritePreferenceString("LastSource", GetGadgetText(#StringGadget_SourceHEX))
    WritePreferenceString("LastFirmw", GL_LastFirmw$)
    WritePreferenceString("LastWriteHEX", GL_LastWiteHEX$)

    PreferenceGroup("LastPIC")
      WritePreferenceLong("LastPIC", GetGadgetState(#ComboGadget_PICType))
      WritePreferenceLong("LastPICFamily", GetGadgetState(#ComboGadget_PICFamily))
      WritePreferenceLong("LastPICSOCKET", GetGadgetState(#ComboGadget_PICSocket)) 

    PreferenceGroup("usburn")
      WritePreferenceString("Path2usburn", GetGadgetText(#String_usburn))
  
    PreferenceGroup("Misc")  
      WritePreferenceLong("DisplayHEX_Reading", GetGadgetState(#CheckGadget_DisplayHEXFile))
      WritePreferenceString("Owner", GetGadgetText(#String_Owner))
    
    ClosePreferences()
  


EndProcedure

Procedure WritePICDatabase()
  CreatePreferences("picDB.ini")
   ForEach PIC()
      If PIC()\Family <> Family$
        Family$ = PIC()\Family
        PreferenceGroup(Family$)
      EndIf  
      WritePreferenceInteger(PIC()\Name, PIC()\Pins)
    Next
    
  ClosePreferences()  
EndProcedure

Procedure OpenMainWindow()
  If OpenWindow(#Window_Main, GL_WindowX, GL_WindowY, 570, 500, "usburnGUI Vers." + GL_Version$)
    PanelGadget(#Panel_Main, 0, 0, 570, 500)
      AddGadgetItem(#Panel_Main, 0, "Burning")
        Frame3DGadget(#FrameGadget_SourceHEX, 10, 10, 550, 60, "Soure - HEX - File:")
          StringGadget(#StringGadget_SourceHEX, 20, 30, 390, 30, GL_LastSourceHEX$)
          ButtonGadget(#ButtonGadget_GetSourceHEX, 420, 30, 130, 30, "Load HEX file")
        
        Frame3DGadget(#FrameGadget_PICType, 10, 80, 550, 100, "PIC type:")
          ComboBoxGadget(#ComboGadget_PICType, 20, 100, 160, 30)
          ComboBoxGadget(#ComboGadget_PICFamily, 190, 100, 130, 30)
          ComboBoxGadget(#ComboGadget_PICSocket, 330, 100, 80, 30)
            AddGadgetItem(#ComboGadget_PICSocket, -1, "8 Pin")
            AddGadgetItem(#ComboGadget_PICSocket, -1, "14 Pin")
            AddGadgetItem(#ComboGadget_PICSocket, -1, "18 Pin")
            AddGadgetItem(#ComboGadget_PICSocket, -1, "28 Pin")
            AddGadgetItem(#ComboGadget_PICSocket, -1, "40 Pin")
            AddGadgetItem(#ComboGadget_PICSocket, -1, "ICSP")
            
          ButtonGadget(#ButtonGadget_AutoDetect, 450, 100, 100, 30, "Autodetect")
          CheckBoxGadget(#CheckGadget_ForceConfig, 30, 140, 240, 30, "Force PIC type from above...")
          TextGadget(#TextGadget_InfoAutodedect, 270, 140, 280, 30, "Please select family and socket!") 
        
        Frame3DGadget(#FrameGadget_PICActions, 10, 200, 550, 90, "PIC - Actions")
          ButtonGadget(#ButtonGadget_WritePIC, 20, 220, 120, 25, "Write PIC")
          ButtonGadget(#ButtonGadget_ReadPIC, 20, 250, 120, 25, "Read PIC")
          ButtonGadget(#ButtonGadget_ComparePIC, 155, 220, 120, 25, "Compare PIC")
          ButtonGadget(#ButtonGadget_TestBlank, 155, 250, 120, 25, "Test Blank")
          ButtonGadget(#ButtonGadget_ErasePIC, 290, 220, 120, 25, "Erase PIC")
          ButtonGadget(#ButtonGadget_RemoveCP, 290, 250, 120, 25, "Remove CP")
          ButtonGadget(#ButtonGadget_Reanimate, 425, 220, 120, 25, "Reanimate")
          ButtonGadget(#ButtonGadget_RunPIC, 425, 250, 120, 25, "Run PIC")
        
  
        ImageGadget(#FakeConsole, 10, 300, #FakeConsoleWidth, #FakeConsoleHeight, 0)
        ScrollBarGadget(#FakeConsoleScroll, 10 + #FakeConsoleWidth, 300, 15, #FakeConsoleHeight, 0, 0, 1, #PB_ScrollBar_Vertical)
    
    AddGadgetItem(#Panel_Main, 1, "Settings")      
      Frame3DGadget(#FrameGadget_PathUsburn, 10, 10, 550, 60, "Path to usburn")
        StringGadget(#String_usburn, 20, 30, 400, 30, GL_usburnPath$)
        ButtonGadget(#Button_DefinePath2usburn, 430, 30, 120, 30, "Select")
        
        ButtonGadget(#ButtonGadget_ActualizeGUIDB, 10, 90, 250, 30, "Sync GUI-DB with usburn")
        ButtonGadget(#ButtonGadget_Calibrate, 280, 130, 250, 30, "Calibrate Brenner8")
        ButtonGadget(#ButtonGadget_FirmUpdate, 280, 90, 250, 30, "Update Brenner8 Firmware")
        
        CheckBoxGadget(#CheckGadget_DisplayHEXFile, 10, 170, 500, 25, "Display HEX file after reading")
        
        SetGadgetState(#CheckGadget_DisplayHEXFile, GL_Display_HEX_reading)
        
        TextGadget(#TextGadget_OwnerGroup, 10, 200, 360, 30, "Owner and group for the downloaded HEX files:")
        StringGadget(#String_Owner, 380, 200, 150, 30, GL_Owner$)
    
    AddGadgetItem(#Panel_Main, 2, "Info")
      EditorGadget(#Editor_Info, 10, 10, 550, 450, #PB_Editor_ReadOnly)
      SetGadgetFont(#Editor_Info, FontID(0))
      
      OpenFile(0, "info.txt")
        While Eof(0) = 0
          AddGadgetItem(#Editor_Info, -1, ReadString(0))
        Wend
      CloseFile(0)
            
      
    AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Escape, 0)
      
  EndIf
EndProcedure

Procedure DisplayHEX(File$)
  If CountGadgetItems(#Panel_Main) > 3
    For item = 3 To CountGadgetItems(#Panel_Main) - 1
      If GetGadgetItemText(#Panel_Main, item) = GetFilePart(File$)
        RemoveGadgetItem(#Panel_Main, item)
      EndIf
    Next
  EndIf
  
  GL_HEX_ID + 1
  
  OpenGadgetList(#Panel_Main)
  AddGadgetItem(#Panel_Main, -1, GetFilePart(File$))
  
    EditorGadget(#Editor_Info + GL_HEX_ID, 10, 10, 500, 450, #PB_Editor_ReadOnly)
    SetGadgetFont(#Editor_Info + GL_HEX_ID, FontID(0))
    
      OpenFile(GL_HEX_ID, File$)
        While Eof(GL_HEX_ID) = 0
          AddGadgetItem(#Editor_Info + GL_HEX_ID, -1, ReadString(GL_HEX_ID))
        Wend
      CloseFile(GL_HEX_ID)
      
      
      
EndProcedure  

Procedure OpenHEX()
  File$ = OpenFileRequester("Please select HEX-File!", GL_LastSourceHEX$, "HEX-Files (*.hex)|*.hex|All Files|*.*", 0)
  
  If File$
  
    GL_LastSourceHEX$ = File$

    SetGadgetText(#StringGadget_SourceHEX, File$)
    
    
    DisplayHEX(File$)
    
    ProcedureReturn 1
    
    
  EndIf  

EndProcedure

Procedure RunAndPost_usburn(Parameter$)
    usburnID = RunProgram(GL_usburnPath$ + "usburn", Parameter$, GL_usburnPath$,  #PB_Program_Open|#PB_Program_Read|#PB_Program_Error)
  
  If usburnID
  
    While ProgramRunning(usburnID)
      
      char.s
      
      chars = AvailableProgramOutput(usburnID)
      If chars
        char.s = Space(chars)
  
        If ReadProgramData(usburnID, @char, chars)
          PrintConsole(char)
        EndIf
      EndIf
      
      Error$ = ReadProgramError(usburnID)
      
      If Error$
        PrintConsoleN(Error$)
      EndIf
      While WindowEvent() : Wend
    Wend
    
    PrintConsoleN("")
    PrintConsoleN("")
    
  Else
    MessageRequester("Error!", "The Program 'usburn' can not be found! Please check your Path!")
  
  EndIf

  
EndProcedure

Procedure SyncGUI_DB()
   usburnID = RunProgram(GL_usburnPath$ + "usburn", "--list", GL_usburnPath$, #PB_Program_Open|#PB_Program_Read)
  
  If usburnID
    ClearList(PIC())
    While ProgramRunning(usburnID)

        WindowEvent()

        DataString$ = ReadProgramString(usburnID)
        PrintConsoleN(DataString$)
 
        If FindString(DataString$, "Database", 1)
          Database = 1
          DataString$ = ReadProgramString(usburnID)
  
        EndIf  
        If Database
          If DataString$ <> "" And (Left(DataString$, 3) = "PIC" Or Left(DataString$, 5) = "dsPIC")
            AddElement(PIC())
              PIC()\Name = StringField(DataString$, 1, " ")
              If FindString(DataString$, "PIC18F", 1) And FindString(DataString$, "K", 1)
                PIC()\Family = "PIC18FxxKxx"
                
              ElseIf FindString(DataString$, "PIC18LF", 1) And FindString(DataString$, "K", 1)
                PIC()\Family = "PIC18LFxxKxx"
                
              ElseIf FindString(DataString$, "PIC16LF", 1)
                PIC()\Family = "PIC18LF"
              
                
              Else
                PIC()\Family = Left(DataString$, FindString(DataString$, "F", 1) - 1)
                
              EndIf
              
              PIC()\Pins = Val(Right(DataString$, 3))
 
             
          EndIf  
        EndIf
    Wend  
  Else
    MessageRequester("Error!", "The Program 'usburn' can not be found! Please check your Path!")
  EndIf
EndProcedure

Procedure FillPICType(Filter$)
  ClearGadgetItems(#ComboGadget_PICType)
  ForEach PIC()
    If PIC()\Family = Filter$ Or Filter$ = ""
      AddGadgetItem(#ComboGadget_PICType, -1, PIC()\Name)
      
    EndIf
  Next  
EndProcedure

Procedure FillPICFamily()
  ClearGadgetItems(#ComboGadget_PICFamily)
  ForEach PIC()
    If PIC()\Family <> Family$
      AddGadgetItem(#ComboGadget_PICFamily, -1, PIC()\Family)
      Family$ = PIC()\Family
    EndIf    
    
  Next  
EndProcedure

Procedure SetPICPins()
  ForEach PIC()
    If PIC()\Name = GetGadgetText(#ComboGadget_PICType)
      If PIC()\Pins < 8 Or PIC()\Pins > 40
        SetGadgetText(#ComboGadget_PICSocket, "ISCP")
      Else
        SetGadgetText(#ComboGadget_PICSocket, Str(PIC()\Pins) + " Pin")
      EndIf
    EndIf 
  Next
EndProcedure

Procedure AutodedectPIC()
    SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
    
    FAMILY$ = GetFamilyFlag()

  usburnID = RunProgram(GL_usburnPath$ + "usburn", " --auto " + SOCKET$ + " " + FAMILY$, GL_usburnPath$, #PB_Program_Open|#PB_Program_Read|#PB_Program_Error)
  
  If usburnID
    While ProgramRunning(usburnID)
        DataString$ = ReadProgramString(usburnID)
        ErrString$ = ReadProgramError(usburnID)
        
        If DataString$
          PrintConsoleN(DataString$)
        EndIf
        
        If ErrString$
          PrintConsoleN(ErrString$)
        EndIf
        
        If FindString(DataString$, "detected Type:", 1)
          If MessageRequester("PIC Typ", "Detected PIC is:" + Chr(10) + "   " + StringField(DataString$, 3, " ") + "  Revision: " + Right(DataString$, 3) + Chr(10) + Chr(10) + "Would you like To set this Type?", #PB_MessageRequester_YesNo ) = #PB_MessageRequester_Yes
            Typ$ = Trim(StringField(DataString$, 3, " "))
            
            If FindString(Typ$, "K", 1)
              SetGadgetText(#ComboGadget_PICFamily, "PIC18FxxKxx")
              
            ElseIf FindString(Typ$, "J", 1)
              SetGadgetText(#ComboGadget_PICFamily, "PIC18FxxJxx")
              
            Else  
              SetGadgetText(#ComboGadget_PICFamily, Left(Typ$, FindString(Typ$, "F", 1) - 1))
            EndIf
            
            FillPICType(GetGadgetText(#ComboGadget_PICFamily))
            
            If Right(Typ$, 1) <> "A"
              SetGadgetText(#ComboGadget_PICType, Typ$)
            Else
              SetGadgetText(#ComboGadget_PICType, Left(Typ$, Len(Typ$) - 1))
            EndIf  
          EndIf
        EndIf  
        If FindString(ErrString$, "unknown", 1)
          MessageRequester("Error!", "Unknown PIC-Type detectet!" +Chr(10) + "Is there any PIC connected with Brenner8?" + Chr(10) + "Please make sure that you have selected the right socket or ISCP!")
        EndIf
        While WindowEvent() : Wend
    Wend  
  Else
    MessageRequester("Error!", "The program 'usburn' can not be found! Please check your path!")
  EndIf

EndProcedure

Procedure BurnFW()

  File$ = OpenFileRequester("Please select the HEX-File for the Brenner8 firmware!", GL_LastFirmw$, "HEX-Files (*.hex)|*.hex|All Files|*.*", 0)

  If File$
    GL_LastFirmw$ = File$
  
    usburnID = RunProgram("xterm", "-hold -e ./usburn -f --IN " + Chr(34) + File$ + Chr(34), GL_usburnPath$)
  
  EndIf


EndProcedure

Procedure Calibrate()
  
    usburnID = RunProgram("xterm", "-hold -e ./usburn -k ", GL_usburnPath$)  

EndProcedure

Procedure Burn()
    
    SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
    
    FAMILY$ = GetFamilyFlag()
    
    If GetGadgetState(#CheckGadget_ForceConfig)
      PIC$ = "--PIC " + GetGadgetText(#ComboGadget_PICType)
    Else
      PIC$ = ""
    EndIf      


  RunAndPost_usburn(" --write " + SOCKET$ + " " + FAMILY$ + " " + PIC$ + " --IN " + Chr(34) + GetGadgetText(#StringGadget_SourceHEX) + Chr(34))

EndProcedure

Procedure ReadPIC()
    File$ = SaveFileRequester("Please select a file to read into!", GL_LastWiteHEX$, "HEX-Files (*.hex)|*.hex|All Files|*.*", 1)
    If File$
      GL_LastWiteHEX$ = File$
    
    SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
    
    FAMILY$ = GetFamilyFlag()
    

      RunAndPost_usburn(" --read " + SOCKET$ + " " + FAMILY$ + " --OUT " + Chr(34) + File$ + Chr(34))

      If GetGadgetText(#String_Owner)
        RunProgram("chown", GetGadgetText(#String_Owner) + ":" + GetGadgetText(#String_owner) + " " + Chr(34) + File$ + Chr(34), "")
        
      EndIf
      
      DisplayHEX(File$)
      
      If GetGadgetState(#CheckGadget_DisplayHEXFile)
        SetGadgetState(#Panel_Main, CountGadgetItems(#Panel_Main) - 1)
      EndIf
    EndIf

EndProcedure

Procedure ComparePIC()
    SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
    
    FAMILY$ = GetFamilyFlag()
        
    RunAndPost_usburn( " --compare " + SOCKET$ + " " + FAMILY$ + " --IN " + Chr(34) + GetGadgetText(#StringGadget_SourceHEX) + Chr(34))

EndProcedure

Procedure ReanimatePIC()
  
  SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
  
  FAMILY$ = GetFamilyFlag()
  
  PIC$ = "--PIC " + GetGadgetText(#ComboGadget_PICType)
    
    
    RunAndPost_usburn(" --reanimate " + SOCKET$ + " " + FAMILY$ + " " + PIC$)
    

EndProcedure

Procedure TestBlankPIC()
  
  SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
  
  FAMILY$ = GetFamilyFlag()  
    
    
    RunAndPost_usburn( " --blank " + SOCKET$ + " " + FAMILY$ + " " + PIC$)
    
EndProcedure

Procedure ErasePIC()
  
  SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
  
  FAMILY$ = GetFamilyFlag()
    
    RunAndPost_usburn(" --erase " + SOCKET$ + " " + FAMILY$ + " " + PIC$)

EndProcedure

Procedure RemoveCP()
  
  SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
  
  FAMILY$ = GetFamilyFlag()
    
    RunAndPost_usburn(" --remove " + SOCKET$ + " " + FAMILY$ + " " + PIC$)
 
EndProcedure

Procedure RunPIC()
  
  SOCKET$ = "--SOCKET " + StringField(GetGadgetText(#ComboGadget_PICSocket), 1, " ")
  
  FAMILY$ = GetFamilyFlag()  
  
  PIC$ = "--PIC " + GetGadgetText(#ComboGadget_PICType)
    
    RunAndPost_usburn(" --run " + SOCKET$ + " " + FAMILY$ + " " + PIC$)
EndProcedure

Procedure Info()

  MessageRequester("Info", "This is a GUI-program for burning PIC C under Linux-OS," + Chr(10) + "using Sprut's Brenner8 and usburn. (www.sprut.de)" + Chr(10) + Chr(10) + "This program is freeware and you can use it without any warranty." + Chr(10) + "You should run this program from an console as root. For example by typing: 'sudo ./usburnGUI'" + Chr(10) + "This program was tested with Ubuntu 9.04. May it don't work with other distributions!" + Chr(10) + "Because this is only a GUI (graphical user interface), you need the program 'usburn' and the database 'picdef03.dat' in the same directory!" + Chr(10) + Chr(10) + "Programmed by C.Knoche" )

EndProcedure

Procedure InitUSBURN()
  
   usburnID = RunProgram(GL_usburnPath$ + "usburn", "", GL_usburnPath$,  #PB_Program_Open|#PB_Program_Read|#PB_Program_Error)
  
  If usburnID
  
    While ProgramRunning(usburnID)
            
      char.s
      
      chars = AvailableProgramOutput(usburnID)
      
      If chars
        char.s = Space(chars)
  
        If ReadProgramData(usburnID, @char, chars)
          PrintConsole(char)
          
        EndIf
      EndIf
      
      Error$ = ReadProgramError(usburnID)
      
      If Error$
        PrintConsoleN(Error$)
        
      EndIf
      
    Wend
  
  Else
    PrintConsoleN("usburn not found!")
  
  EndIf


EndProcedure
; IDE Options = PureBasic 4.61 (Linux - x64)
; CursorPosition = 581
; Folding = AAAAg
; EnableXP
; UseMainFile = usburnGUI.pb
; Executable = ../usburnGUI
; CurrentDirectory = ../
; EnableExeConstant